# Jenkins configure

Job runs at: [Centos OpenShift](https://jenkins-fedora-atomic-process.apps.ci.centos.org/credentials/)

In job configure:

* At **Job Notifications** add Notification Endpoints.
* At **Build Triggers** add **Trigger builds remotely (e.g., from scripts)**

More at: [Pagure CI for Jenkins](https://docs.pagure.org/pagure/usage/pagure_ci_jenkins.html)

#### Grant to Anonymous user Read access

"Manage Jenkins" -> "Configure Global Security" and for "Anonymous Users" check:

* Overall = Read
* Job = Read

#### Copr config

Jenkins -> Credentials -> System -> Global credentials (unrestricted) ->  Add Credentials

Type: Secret file.

Assign `secret_id_for_copr_config` for ID.

# OpenShift

Create an image with:

    cat Dockerfile | oc new-build -D -  --name='str-tester'

This image will be used as Jenkins slave for testing needs.
Workflow is based on Kubernetes plugin:

* [Jenkins portal page](https://jenkins.io/doc/pipeline/steps/kubernetes/)
* [Github project](https://github.com/jenkinsci/kubernetes-plugin)

# Useful links

* [Jenkinsfile](https://jenkins.io/doc/book/pipeline/jenkinsfile/)
* [Groovy syntax](http://groovy-lang.org/syntax.html)
* [Pipeline](https://jenkins.io/doc/book/pipeline/)
* [Pipeline syntax](https://jenkins.io/doc/book/pipeline/syntax/)
* [Pipeline steps](https://jenkins.io/doc/pipeline/steps/)
* [Pipeline workflow](https://jenkins.io/doc/pipeline/steps/workflow-basic-steps/)
* [Tutorial pipeline](https://github.com/jenkinsci/pipeline-plugin/blob/master/TUTORIAL.md)

