# Terminology

* **Test Subject**: The items that are to be tested. Examples: RPMs, OCI image,
  ISO, QCow2, Module repository ...
* **Test**: A callable/runnable piece of code and corresponding test data and
  mocks which exercises and evaluates a test subject.
* **Test environment**: environment where actual test run takes place. Test has
  direct impact on test environment.
* **Test Suite**: The collection of all tests that apply to a test subject.
* **Test Framework**: A library or component that the test suite and tests use
  to accomplish their job. Examples: Avocado, GNOME Installed Tests, Meta Test
  Family, Ansible tests in Atomic Host, Tunir tests, docker test images, ... 
* **Test Result**: A boolean pass/fail output of a test suite.  Test results
  are for consumption by automated aspects of a testing systems.
* **Test Artifact**: Any additional output of the test suite such as the
  stdout/stderr output, log files, screenshots, core dumps, or
  TAP/Junit/subunit streams. Test artifacts are for consumption by humans,
  archival or big data analysis.
* **Testing System**: A CI or other testing system that would like to discover,
  stage and invoke tests for a test subject. Examples: Jenkins, Taskotron,
  ZUUL, CentOS CI, Papr, Travis, Semaphore, Openshift CI/CD, Ubuntu CI, ... 
* **Test runner**: Testing system uses test runner as a place for running
tests. Testing system delegates test-running to test runner. Test runner
examples: local machine, VM,...
